/**
 * @file Main.cpp
 * @date 2015-05-24
 * @brief Tv\[XR[h
 */
// for January2015v3

#include "modelconverter.hpp"
#include "pmd.hpp"

#include "HamFramework\SceneManager.hpp"

#define FSL L"Large"
#define FSM L"Medium"
#define FSS L"Small"

#define AXISH (0.25)
#define AXISI (5.0)

/// <summary>ŜŎgp</summary>
struct Data {
	/// <summary>GUIz</summary>
	Array<GUI> guis;
	/// <summary>^C}[</summary>
	TimerMillisec timerMilli;

	/// <summary>ϊѕ`p</summary>
	Array<ModelConverter> converters;
	/// <summary>CX^X1</summary>
	Array<MotionInstance> mis;

	/// <summary>]</summary>
	double ang = 0;
	/// <summary>ݒUI</summary>
	bool uiVisible = true;
	/// <summary>IvVݒUI</summary>
	bool optionUiVisible = false;

	/// <summary>bZ[Wp</summary>
	Effect effect;


	/// <summary></summary>
	void btMake(bool enabled) {
		guis[0].button(L"bt_make").enabled = enabled;
	}
};

using MyApp = ham::SceneManager<String,Data>;

/// <summary>bZ[W\</summary>
struct Message : IEffect {
	String msg;
	/// <summary>YW</summary>
	int my = 100;
	/// <summary>RXgN^</summary>
	Message(String inMsg) {
		msg = inMsg;
	}
	/// <summary>XV</summary>
	bool update(double t) override {
		double alpha = 1.0;
		if (t < 1.0) {
			alpha = t;
		}
		else if (t > 4.0) {
			alpha = 5.0 - t;
		}
		ColorF c0(Palette::White,alpha);
		ColorF c1(Palette::Black,alpha);

		int y = my - (int)Math::Floor(t*20);

		FontAsset(FSS)(msg).drawCenter(y+2, c1);
		FontAsset(FSS)(msg).drawCenter(y, c0);
		return t < 5.0;
	}
};

/// <summary>X^[gAbv</summary>
struct Startup : MyApp::Scene {
	/// <summary></summary>
	void init() override {
		FontAsset::Register(FSL, 48, Typeface::Black, FontStyle::Outline);
		FontAsset::Register(FSM, 32, Typeface::Black, FontStyle::Outline);
		FontAsset::Register(FSS, 16, Typeface::Black, FontStyle::Outline);

		FontAsset(FSL).changeOutlineStyle({ Palette::Midnightblue, Palette::Whitesmoke, 3 });
		FontAsset(FSM).changeOutlineStyle({ Palette::Black, Palette::White, 2 });
		FontAsset(FSS).changeOutlineStyle({ Palette::Black, Palette::White, 1 });


		Window::SetTitle(L".mqo.pmdϊ 1");
		Window::SetStyle(WindowStyle::Sizeable);
		Dragdrop::SetEnabled(true);

		Window::Resize({800,600});

		Camera cam = Graphics3D::GetCamera();
		cam.pos = { 0, 25, -80 };
		cam.lookat = { 0, 20, 0 };
		Graphics3D::SetCamera(cam);

		m_data->timerMilli.start();

		GUI gui(GUIStyle::Default);
		gui.setTitle(L"ݒ");

		gui.add(L"tx_fps", GUIText::Create(L"-"));
		gui.add(GUIText::Create(L"fps"));
		gui.add(GUIText::Create(L"JE^"));
		gui.addln(L"tx_counter", GUIText::Create(L"-"));

		gui.addln(L"cb_deci", GUICheckBox::Create({ L"0.1{" }, {0}));
		gui.addln(L"cb_dblface", GUICheckBox::Create({ L"ʑfނ͖ʒǉɂ" }));

		gui.add(L"bt_open", GUIButton::Create(L"J"));
		gui.addln(L"bt_clear", GUIButton::Create(L"NA"));

		gui.add(GUIText::Create(L"ӏƖ"));
		gui.add(L"sl_amb", GUISlider::Create(0, 100, 50));
		gui.addln(L"tx_amb", GUIText::Create(L"0.50"));
		Graphics3D::SetAmbientLight(ColorF(0.50));

		gui.add(L"cb_axis", GUICheckBox::Create({ L"ڐ\" }));
		gui.addln(L"bt_bgc", GUIButton::Create(L"wiF"));

		gui.add(L"cb_wire", GUICheckBox::Create({L"C[t[\"}));
		gui.addln(L"cb_rot", GUICheckBox::Create({ L"]" }));

		gui.addln(L"bt_make", GUIButton::Create(L"pmdo"));

		const Rect rc = gui.getRect();
		gui.setPos(Window::Width() - rc.w - 4, Window::Height() - rc.h - 4);
		gui.hide();

		m_data->guis.push_back(gui);
		m_data->btMake(false);

// IvVUI
		GUI gui2(GUIStyle::Default);
		gui2.setTitle(L"IvVݒ");
		gui2.addln(GUIText::Create(L"ݒ荀ڂ͂܂"));
		gui2.setPos(4, 4);
		gui2.hide();
		m_data->guis.push_back(gui2);
	}
	/// <summary>XV</summary>
	void update() override {
		changeScene(L"MainScene");
	}
	/// <summary>`</summary>
	void draw() const override {
		FontAsset(FSM)(L"Please wait a minutes...").drawCenter(100);
	}

};

/// <summary>CV[</summary>
struct MainScene : MyApp::Scene {
	/// <summary></summary>
	void init() override {
		m_data->guis[0].show();
	}
	/// <summary>XV</summary>
	void update() override {
		Graphics3D::FreeCamera();

		bool isRot = m_data->guis[0].checkBox(L"cb_rot").checked(0);
		if (isRot) {
			m_data->ang += 0.01;
		}

		m_data->guis[0].text(L"tx_fps").text = ToString(Profiler::FPS());
		m_data->guis[0].text(L"tx_counter").text = ToString(System::FrameCount());

		if (m_data->guis[0].slider(L"sl_amb").hasChanged) {
			auto lv = m_data->guis[0].slider(L"sl_amb").valueInt;
			m_data->guis[0].text(L"tx_amb").text = Format(lv / 100, L".", Pad<int>(lv % 100, {2,'0'}));
			Graphics3D::SetAmbientLight(ColorF(0.01 * (double)lv));
		}

		if (Input::KeyF6.clicked) {
			m_data->uiVisible = !m_data->uiVisible;
			m_data->guis[0].show(m_data->uiVisible);
		}
		if (Input::KeyF7.clicked) {
			m_data->optionUiVisible = !m_data->optionUiVisible;
			m_data->guis[1].show(m_data->optionUiVisible);
		}

		if (m_data->guis[0].checkBox(L"cb_wire").hasChanged) {
			if (m_data->guis[0].checkBox(L"cb_wire").checked(0)) {
				Graphics3D::SetRasterizerState(RasterizerState::WireframeNone);
			}
			else {
				Graphics3D::SetRasterizerState(RasterizerState::Default3D);
			}
		}

		if (m_data->guis[0].checkBox(L"cb_rot").checked(0)) {
			m_data->ang += Math::TwoPi / 3600.0;
		}

		if (m_data->guis[0].button(L"bt_bgc").pushed) {
			auto c = Dialog::GetColor();
			if (c) {
				Graphics::SetBackground(c.value());
			}
		}
		if (m_data->guis[0].button(L"bt_clear").pushed
			|| Input::KeyDelete.clicked) {
			this->ClearModel();
		}
		if (m_data->guis[0].button(L"bt_open").pushed) {
			if (auto open = Dialog::GetOpen({ {L"Model(*.mqo)",L"*.mqo"},
				{L"All",L"*.*"} })) {
				OpenMqo(open.value());
			}
		}

		if (Dragdrop::HasItems()) {
			auto paths = Dragdrop::GetFilePaths();
			for (auto path : paths) {
				OpenMqo(path);
			}
		}

		if (m_data->guis[0].button(L"bt_make").pushed) {
			bool result = OutputPmd();
			if (result) {
				m_data->effect.add<Message>(L"o͂܂");
			}
			else {
				m_data->effect.add<Message>(L"s܂");
			}
		}

		for (auto& mi : m_data->mis) {
			if (mi.optIdx == false) {
				continue;
			}
			// [VKp
			for (int i = 0; i < mi.nodes.size(); ++i) {
				auto& node = mi.nodes[i];
				double ang = (isRot) ? m_data->ang : 0;
				node.motionRot = Quaternion::Yaw(ang);
			}
			mi.ComputeCurCoordinates();
		}

		m_data->effect.update();
	}
	/// <summary>`</summary>
	void draw() const override {
		if (m_data->guis[0].checkBox(L"cb_axis").checked(0)) {
			Box({-AXISH,-AXISH,-AXISH}, AXISH * 2).draw(Palette::Yellow);
			for (int i = 1; i <= 10; ++i) {
				Cone(i*5, -AXISH*2, 0, AXISH, AXISH * 2).draw(Palette::Red);
				Cone(-AXISH*2, i*5, 0, AXISH, AXISH * 2,
					Quaternion::Roll(-HalfPi)).draw(Palette::Green);
				Cone(0, -AXISH*2, i*5, AXISH, AXISH * 2).draw(Palette::Mediumblue);
			}
		}

		for (auto& mi : m_data->mis) {
			if (mi.optIdx == false) {
				continue;
			}
			int idx = mi.optIdx.value();
			if (idx >= m_data->converters.size()) {
				continue;
			}
			const auto& mc = m_data->converters[idx];
			int matNum = mc.mats.size();

			for (int i = 0; i < mi.nodes.size(); ++i) {
				if (mc.meshes[i].isEmpty) {
					//Println(L"̃bV, ", i);
					continue;
				}

				const auto& node = mi.nodes[i];
				Mat4x4 cur = node.GetCurMat();

				for (int j = 0; j < matNum; ++j) {
					if (j >= node.groups.size()) {
						continue;
					}
					const auto& gr = node.groups[j];
					if (gr.num() <= 0) {
						continue;
					}

					const auto& mat = mc.mats[j];
					Vec3 v3(mat.diffuse.r + mat.ambient.r + mat.emission.r,
						mat.diffuse.g + mat.ambient.g + mat.emission.g,
						mat.diffuse.b + mat.ambient.b + mat.emission.b);
					ColorF c(Clamp(v3, 0, 1));

					if (i >= mc.meshes.size()) {
						//Println(L"bVCfbNXG[ ",
						//	i,L" ",j,L" ",mc.meshes.size(),L" ",mc.mats.size());
						continue;
					}

					mc.meshes[i].drawSubset(gr.offset,
						gr.num(),
						cur,
						mc.texs[j],
						c);
				}
			}
		}

	}

	/// <summary>f̓ǂݏoԂNA</summary>
	void ClearModel() {
		ClearPrint();
		m_data->converters.clear();
		m_data->mis.clear();
		m_data->btMake(false);
	}

	/// <summary>.mqot@Cǂݍ݃fpӂ</summary>
	void OpenMqo(String inPath) {
		this->ClearModel();

		TextReader r;
		bool result = r.open(inPath);
		if (result == false) {
			m_data->effect.add<Message>(L"I[vɎs܂");
			return;
		}

		ModelConverter mc;

		MqoFile mqo;
		mqo.clear();
		mqo.path = inPath;
		MqoFiler filer;
		result = filer.LoadMqo(r,mqo);
		if (result == false) {
			m_data->effect.add<Message>(L"[hɎs܂");
			return;
		}

		Array<String> options;
		if (m_data->guis[0].checkBox(L"cb_dblface").checked(0)) {
			options.push_back(L"addFaceForDouble");
		}
		double rate = (m_data->guis[0].checkBox(L"cb_deci").checked(0)) ? 0.1 : 1.0;

		result = mc.ApplyMqo(mqo,rate,options);
		if (result) {
			MotionInstance mi = mc.CreateMotionInstance();
			mi.optIdx.emplace(m_data->converters.size());

			m_data->converters.push_back(mc);
			m_data->mis.push_back(mi);

			m_data->effect.add<Message>(L"\܂");
			for (const auto& l : mqo.scene.dirlights) {
				Light dir = Light::Directional(rev_z(l.dir),l.color);
				Graphics3D::SetLight(0, dir);
			}
			m_data->btMake(true);
		}
		else {
			m_data->effect.add<Message>(L"s܂");
		}
	}

	/// <summary>.pmdt@Co͂</summary>
	bool OutputPmd() {
		if (m_data->converters.size() < 1) {
			return false;
		}

		PmdFile pmd;
		bool result = m_data->converters[0].ConvertToPmd(pmd);
		if (result == false) {
			return false;
		}

		auto outPath = Dialog::GetSave({ { L"pmdt@C(*.pmd)", L"*.pmd" } });
		if (!outPath) {
			return false;
		}

		PmdFiler pmdFiler;
		BinaryWriter w(outPath.value());
		result = pmdFiler.SavePmd(pmd,w);
		if (result == false) {
			return false;
		}
		return true;
	}
};

/// <summary>C֐</summary>
void Main() {
	MyApp myApp;
	myApp.add<Startup>(L"Startup");
	myApp.add<MainScene>(L"MainScene");
	while (System::Update()) {
		if (!myApp.updateAndDraw()) {
			break;
		}
	}
}
