/**
 * @file pmd.hpp
 * @date 2015-05-24
 * @brief Tv\[XR[h
 */
// for January2015v3

#pragma once

#include <Siv3D.hpp>

typedef unsigned char u8;
typedef unsigned short u16;
typedef unsigned int u32;

#define PMDBONE_ROT (0)
#define PMDBONE_ROTMOV (1)
#define PMDBONE_IK (2)
#define PMDBONE_3 (3)
#define PMDBONE_UNDERIK (4)
#define PMDBONE_UNDERROT (5)
#define PMDBONE_IKCONNECT (6)
#define PMDBONE_HIDE (7)
#define PMDBONE_TWIST (8)
#define PMDBONE_ROTMOVEMENT (9)

	/// <summary>_</summary>
	struct PmdVertex {
		/// <summary>ʒu</summary>
		Vec3 position;
		/// <summary>@</summary>
		Vec3 normal;
		/// <summary>@</summary>
		Vec2 texcoord;

		/// <summary>e{[</summary>
		int bones[2];
		/// <summary>0`100:ŏ̃{[ւ̃EFCg</summary>
		int weight = 100;

		/// <summary>0:ʏA1:GbW</summary>
		int edgeFlag;
	};

	/// <summary>ގ</summary>
	struct PmdMaterial {
		/// <summary>gU</summary>
		ColorF diffuse;

		/// <summary>XyL</summary>
		double power;
		/// <summary>XyLF</summary>
		ColorF specular;
		/// <summary></summary>
		ColorF ambient;

		/// <summary>255: 0.bmp, 0: 1.bmp, 1: 2.bmp, ..., 9: 10.bmp</summary>
		int toonIndex = 255;
		/// <summary>֊sAe</summary>
		int edgeFlag = 0;

		/// <summary>ގɊ܂܂钸_</summary>
		int matVertexNum = 0;
		/// <summary>eNX`t@C</summary>
		String texName;
	};

	/// <summary>{[</summary>
	struct PmdBone {
		/// <summary></summary>
		String name;
		/// <summary>en</summary>
		String nameE;

		/// <summary>e{[̃CfbNXAꍇ-1</summary>
		int parent = -1;

		/// <summary>\Aꍇ0</summary>
		int child = 0;
		/// <summary></summary>
		int type;
		/// <summary>IK̐e</summary>
		int ikParent;

		/// <summary>ʒu</summary>
		Vec3 position;
	};

	/// <summary>[t</summary>
	struct PmdMorph {
		/// <summary>(20oCg܂)</summary>
		String name;
		/// <summary>en</summary>
		String nameE;

		/// <summary>0:base, 1:܂, 2:, 3:bv, 4:̑</summary>
		int type;

		/// <summary>_ԍ</summary>
		Array<int> indices;
		/// <summary>baseȂ玩gAbaseȊO͑</summary>
		Array<Vec3> vertices;
	};

	/// <summary>\g</sumary>
	struct PmdFrame {
		/// <summary></summary>
		String name;
		/// <summary>en</summary>
		String nameE;

		/// <summary>{[</summary>
		Array<int> bones;
	};

	/// <summary></summary>
	struct PmdBody {
		/// <summary></summary>
		String name;

		/// <summary>֘A{[</summary>
		int bone;
		/// <summary>O[v</summary>
		int group;
		/// <summary>Փ</summary>
		int colli;
		/// <summary>Ȃ</summary>
		int shape;

		/// <summary>TCY</summary>
		Vec3 size;

		/// <summary>ʒu</summary>
		Vec3 position;
		/// <summary>]</summary>
		Vec3 rotation;

		/// <summary></summary>
		double wt;
		/// <summary>ړ</summary>
		double movAttenuation;
		/// <summary>]</summary>
		double rotAttenuation;
		/// <summary></summary>
		double pong;
		/// <summary>C</summary>
		double friction;

		/// <summary>0: Ǐ]A1: Z</summary>
		int type;
	};

	/// <summary>WCg</summary>
	struct PmdJoint {
		/// <summary></summary>
		String name;

		/// <summary>A</summary>
		int bodyA;
		/// <summary>B</summary>
		int bodyB;

		/// <summary>ʒu</summary>
		Vec3 position;
		/// <summary>]</summary>
		Vec3 rotation;

		/// <summary>ړ</summary>
		Vec3 movLower;
		/// <summary>ړ</summary>
		Vec3 movUpper;
		/// <summary>]</summary>
		Vec3 rotLower;
		/// <summary>]</summary>
		Vec3 rotUpper;
		/// <summary>ړ΂</summary>
		Vec3 movSpring;
		/// <summary>]΂</summary>
		Vec3 rotSpring;
	};

	/// <summary>1̃t@C\</summary>
	struct PmdFile {
		/// <summary>o[W</summary>
		double ver = 1.0;

		/// <summary>f</summary>
		String name;
		/// <summary>Model name</summary>
		String nameE;
		/// <summary>Rg</summary>
		String comment;
		/// <summary>Comment</summary>
		String commentE;

		/// <summary>_</summary>
		Array<PmdVertex> vertices;

		/// <summary>ʒ_CfbNX</sumary>
		Array<int> faces;

		/// <summary>eNX`</summary>
		Array<String> texNames;
		/// <summary>ގ</summary>
		Array<PmdMaterial> materials;

		/// <summary>{[</summary>
		Array<PmdBone> bones;

		/// <summary>[t</summary>
		Array<PmdMorph> morphs;
		/// <summary>\g</summary>
		Array<PmdFrame> frames;

		/// <summary>Z</summary>
		Array<PmdBody> bodies;
		/// <summary>WCg</summary>
		Array<PmdJoint> joints;


		/// <summary>zNA</summary>
		void clear() {
			this->vertices.size();
			this->faces.size();
			this->texNames.size();
			this->materials.size();
			this->bones.clear();
			this->morphs.clear();
			this->frames.clear();
			this->bodies.clear();
			this->joints.clear();
		}
	};

	/// <summary>t@C</summary>
	struct PmdFiler {
		/// <summary>Œ蒷obt@ɕ𖄂ߍ</summary>
		/// <param name="buf">mۍς݃obt@</param>
		/// <param name="num">obt@oCg</param>
		/// <param name="s"></param>
		/// <param name="nullTerminate">NULL~ߗL</param>
		/// <returns>true: Afalse: s</returns>
		bool setPmdText(char* buf, int num, String s, bool nullTerminate = true) const {
			::memset(buf, 0, num);

			std::string ms = s.narrow();
			int len = ::strlen(ms.c_str());
			int size = Min(len, num - (nullTerminate == true));
			::memcpy(buf, ms.c_str(), size);
			return (size >= len);
		}

		/// <summary>.pmdt@Co͂</summary>
		/// <param name="f">.pmd̏</param>
		/// <param name="w">oCiC^</param>
		bool SavePmd(const PmdFile& f, BinaryWriter w) const {
			char buf[256];

			// wb_
			setPmdText(buf, 3, L"Pmd", false);
			w.write(buf, 3);
			w.write<float>(1.0f);
			setPmdText(buf, 20, f.name);
			w.write(buf, 20);
			setPmdText(buf, 256,f.comment);
			w.write(buf, 256);
			// _
			int num = f.vertices.size();
			w.write<int>(num);
			for (const auto& v : f.vertices) {
				w.write<float>(v.position.x);
				w.write<float>(v.position.y);
				w.write<float>(v.position.z);
				w.write<float>(v.normal.x);
				w.write<float>(v.normal.y);
				w.write<float>(v.normal.z);
				w.write<float>(v.texcoord.x);
				w.write<float>(v.texcoord.y);

				w.write<short>(v.bones[0]);
				w.write<short>(v.bones[1]);
				w.write<u8>(v.weight);
				w.write<u8>(v.edgeFlag);
			}

			// _CfbNX
			num = f.faces.size();
			w.write<int>(num);
			for (const auto& idx : f.faces) {
				w.write<u16>(idx);
			}
			// ގ
			num = f.materials.size();
			w.write<int>(num);
			for (const auto& mat: f.materials) {
				ColorF c = mat.diffuse;
				w.write<float>(c.r);
				w.write<float>(c.g);
				w.write<float>(c.b);
				w.write<float>(c.a);

				w.write<float>(mat.power);

				c = mat.specular;
				w.write<float>(c.r);
				w.write<float>(c.g);
				w.write<float>(c.b);

				c = mat.ambient;
				w.write<float>(c.r);
				w.write<float>(c.g);
				w.write<float>(c.b);

				w.write<u8>(mat.toonIndex);
				w.write<u8>(mat.edgeFlag);
				w.write<int>(mat.matVertexNum);
				// NULL~ߏԂɂ(MMM̂߂)
				setPmdText(buf, 20, mat.texName, true);
				w.write(buf, 20);
			}
			// {[
			num = f.bones.size();
			w.write<short>(num);
			for (const auto& bone: f.bones) {
				setPmdText(buf, 20, bone.name);
				w.write(buf, 20);
				w.write<short>(bone.parent);
				w.write<short>(bone.child);
				w.write<u8>(bone.type);
				w.write<u16>(bone.ikParent);

				w.write<float>(bone.position.x);
				w.write<float>(bone.position.y);
				w.write<float>(bone.position.z);
			}
			// IKXg
			w.write<u16>(0); // ĂȂ

			// \Xg
			int morphNum = f.morphs.size();
			w.write<u16>(morphNum);
			for (int i = 0; i < morphNum; ++i) {
				PmdMorph morph = f.morphs[i];
				setPmdText(buf, 20, morph.name);
				w.write(buf, 20);
				auto num = Min(morph.indices.size(),
					morph.vertices.size());
				w.write(num);
				w.write<u8>(morph.type);
				for (int j = 0; j < num; ++j) {
					w.write(morph.indices[j]);
					w.write<float>(morph.vertices[j].x);
					w.write<float>(morph.vertices[j].y);
					w.write<float>(morph.vertices[j].z);
				}
			}
			// \gp\Xg
			w.write<u8>(morphNum);
			for (int i = 0; i < morphNum; ++i) {
				setPmdText(buf, 20, f.morphs[i].name,true);
				w.write(buf, 20);
			}
			// {[gpgXg
			int frameNum = f.frames.size();
			w.write<u8>(frameNum);

			num = 0; // SJEg
			for (int i = 0; i < frameNum; ++i) {
				setPmdText(buf, 50, f.frames[i].name);
				w.write(buf, 50);

				num += f.frames[i].bones.size();
			}
			// {[gp\Xg
			w.write<u32>(num);
			for (int i = 0; i < frameNum; ++i) {
				for (int j = 0; j < f.frames[i].bones.size(); ++j) {
					w.write<u16>(f.frames[i].bones[j]); // {[ԍ
					w.write<u8>(i+1); // 0:Z^[pgA1`:Z^[pgȊO
				}
			}

			// p
			int isEn = 1;
			w.write<u8>(isEn);
			if (isEn) {
				setPmdText(buf, 20, f.nameE,false);
				w.write(buf, 20);
				setPmdText(buf, 256, f.commentE);
				w.write(buf, 256);
				for (int i = 0; i < f.bones.size(); ++i) {
					setPmdText(buf, 20, f.bones[i].nameE);
					w.write(buf, 20);
				}
				for (int i = 0; i < morphNum; ++i) {
					setPmdText(buf, 20, f.morphs[i].nameE);
					w.write(buf, 20);
				}
				for (int i = 0; i < frameNum; ++i) {
					setPmdText(buf, 50, f.frames[i].nameE);
					w.write(buf, 50);
				}
			}

			// gD[
			for (int i = 0; i < 10; ++i) {
				String name = Format(L"toon", i + 1, L".bmp");
				setPmdText(buf, 100, name);
				w.write(buf, 100);
			}
			// 
			num = f.bodies.size();
			w.write<u32>(num);
			for (const auto& body : f.bodies) {
				setPmdText(buf, 20, body.name);
				w.write(buf, 20);
				w.write<u16>(body.bone);
				w.write<u8>(body.group);
				w.write<u16>(body.colli);
				w.write<u8>(body.shape);
				w.write<float>(body.size.x);
				w.write<float>(body.size.y);
				w.write<float>(body.size.z);
				w.write<float>(body.position.x);
				w.write<float>(body.position.y);
				w.write<float>(body.position.z);
				w.write<float>(body.rotation.x);
				w.write<float>(body.rotation.y);
				w.write<float>(body.rotation.z);
				w.write<float>(body.wt);
				w.write<float>(body.movAttenuation);
				w.write<float>(body.rotAttenuation);
				w.write<float>(body.pong);
				w.write<float>(body.friction);
				w.write<u8>(body.type);
			}

			// WCg
			num = f.joints.size();
			w.write<u32>(num);
			for (const auto& j : f.joints) {
				setPmdText(buf, 20, j.name);
				w.write(buf, 20);
				w.write<u32>(j.bodyA);
				w.write<u32>(j.bodyB);
				w.write<float>(j.position.x);
				w.write<float>(j.position.y);
				w.write<float>(j.position.z);
				w.write<float>(j.rotation.x);
				w.write<float>(j.rotation.y);
				w.write<float>(j.rotation.z);

				w.write<float>(j.movLower.x);
				w.write<float>(j.movLower.y);
				w.write<float>(j.movLower.z);
				w.write<float>(j.movUpper.x);
				w.write<float>(j.movUpper.y);
				w.write<float>(j.movUpper.z);

				w.write<float>(j.rotLower.x);
				w.write<float>(j.rotLower.y);
				w.write<float>(j.rotLower.z);
				w.write<float>(j.rotUpper.x);
				w.write<float>(j.rotUpper.y);
				w.write<float>(j.rotUpper.z);

				w.write<float>(j.movSpring.x);
				w.write<float>(j.movSpring.y);
				w.write<float>(j.movSpring.z);
				w.write<float>(j.rotSpring.x);
				w.write<float>(j.rotSpring.y);
				w.write<float>(j.rotSpring.z);
			}
			return true;
		}
	};
